<?php
namespace Inti\Gath\Api\Result;

use Inti\Gath\Api\Record\ProductAttributeRecord;

/**
 * Interface GetAttributesResult
 *
 * @package Inti\Gath\Api\Result
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 *
 * @property ProductAttributeRecord[] $Results
 */
final class GetProductAttributesResult extends AbstractResult
{
    /** @var string */
    protected $recordClass = ProductAttributeRecord::class;

    public function __construct(array $data)
    {
        if (isset($data['Results'][0]['Attributes'])) {
            $data = [
                'Results' => $data['Results'][0]['Attributes'] ?? [],
            ];

            foreach ($data['Results'] as &$attribute) {
                $attribute['values'] = array_map(function ($value) {
                    return $value['value'];
                }, $attribute['values']);
            }
        }

        parent::__construct($data);
    }
}
